package YHProto

import (
	"bytes"
	"crypto/aes"
	"crypto/cipher"
	"fmt"
)

var (
	algorithm = 1
)

func Encrypt(plaintext []byte) ([]byte, error) {
	switch algorithm {
	case 1: // AES-128-CBC
		block, err := aes.NewCipher([]byte(echoPkgKey))
		if err != nil {
			return nil, err
		}
		paddedPlaintext := PKCS5Padding(plaintext, block.BlockSize())
		iv := make([]byte, block.BlockSize())
		stream := cipher.NewCTR(block, iv)
		ciphertext := make([]byte, len(paddedPlaintext))
		stream.XORKeyStream(ciphertext, paddedPlaintext)
		return ciphertext, nil
	default:
		return nil, fmt.Errorf("unsupported encryption algorithm %d", algorithm)
	}
}

func Decrypt(ciphertext []byte) ([]byte, error) {
	switch algorithm {
	case 1: // AES-128-CBC
		block, err := aes.NewCipher([]byte(echoPkgKey))
		if err != nil {
			return nil, err
		}
		iv := make([]byte, block.BlockSize())
		stream := cipher.NewCTR(block, iv)
		plaintext := make([]byte, len(ciphertext))
		stream.XORKeyStream(plaintext, ciphertext)
		return PKCS5Trimming(plaintext), nil
	default:
		return nil, fmt.Errorf("unsupported encryption algorithm %d", algorithm)
	}
}

func PKCS5Padding(data []byte, blockSize int) []byte {
	padding := blockSize - len(data)%blockSize
	padtext := bytes.Repeat([]byte{byte(padding)}, padding)
	return append(data, padtext...)
}

func PKCS5Trimming(data []byte) []byte {
	padding := int(data[len(data)-1])
	return data[:len(data)-padding]
}

func VerifySignature(signature []byte, privateKey []byte) bool {
	// Signature verification logic goes here
	return true
}

func TamperProof(body []byte) []byte {
	// Data tamper-proofing logic goes here
	return body
}
